function [x_grid, y_grid, z_grid] = PlanarSurface_GridCoordinates(choice,plane_definition, limits, nr_a_values, nr_b_values)
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here
%
%  choice = 'radial' or 'rectangle'; 
%  plane_definition = [y_axis_rotation_angle z_axis_rotation_angle x_axis_shift];
%  limits = [a_min a_max b_min b_max];
%  nr_a_values = grid increments;
%  nr_b_values = grid increments;
%

if strcmp(choice,'rectangle') == 1
    
    a_values = linspace(limits(1),limits(2),nr_a_values);
    b_values = linspace(limits(3),limits(4),nr_b_values);

    [a_grid, b_grid] = meshgrid(a_values,b_values);
    a_grid_r = reshape(a_grid,size(a_grid,1)*size(a_grid,2),1)';
    b_grid_r = reshape(b_grid,size(b_grid,1)*size(b_grid,2),1)';

    c_grid_r = zeros(1,numel(a_grid_r));

    spatial_info = zeros(3,numel(a_grid_r));   

    spatial_info(1,:) = a_grid_r;                  %
    spatial_info(2,:) = b_grid_r;                  % 
    spatial_info(3,:) = c_grid_r;                  %

    y_rot_angle = plane_definition(1);
    R_y = [cosd(y_rot_angle) 0 sind(y_rot_angle); 0 1 0; -sind(y_rot_angle) 0 cosd(y_rot_angle)];
    y_axis_rotation = R_y*spatial_info;

    z_rot_angle = plane_definition(2);
    R_z = [cosd(z_rot_angle) -sind(z_rot_angle) 0; sind(z_rot_angle) cosd(z_rot_angle) 0; 0 0 1];
    z_axis_rotation = R_z*y_axis_rotation;

    x_axis_shift = plane_definition(3);
    spatial_info = x_axis_shift*ones(3,numel(a_grid_r)) + z_axis_rotation;

    x_grid = reshape(spatial_info(1,:),nr_b_values,nr_a_values);
    y_grid = reshape(spatial_info(2,:),nr_b_values,nr_a_values);
    z_grid = reshape(spatial_info(3,:),nr_b_values,nr_a_values);
    
end


if strcmp(choice,'radial') == 1
    
    r_values = linspace(limits(1),limits(2),nr_a_values);
    phi_values = linspace(limits(3),limits(4),nr_b_values);

    [r_grid, phi_grid] = meshgrid(r_values,phi_values);
    theta_grid = (90)*ones(numel(phi_values),numel(r_values));
    
    x_grid = cosd(phi_grid) .* sind(theta_grid) .* abs(r_grid);
    y_grid = sind(phi_grid) .* sind(theta_grid) .* abs(r_grid);
    z_grid = cosd(theta_grid) .* abs(r_grid);
    
    x_grid_r = reshape(x_grid,size(x_grid,1)*size(x_grid,2),1).';
    y_grid_r = reshape(y_grid,size(y_grid,1)*size(y_grid,2),1).';
    z_grid_r = reshape(z_grid,size(z_grid,1)*size(z_grid,2),1).';

    spatial_info = zeros(3,numel(x_grid_r));   

    spatial_info(1,:) = x_grid_r;                  %
    spatial_info(2,:) = y_grid_r;                  % 
    spatial_info(3,:) = z_grid_r;                  %

    y_rot_angle = plane_definition(1);
    R_y = [cosd(y_rot_angle) 0 sind(y_rot_angle); 0 1 0; -sind(y_rot_angle) 0 cosd(y_rot_angle)];
    y_axis_rotation = R_y*spatial_info;

    z_rot_angle = plane_definition(2);
    R_z = [cosd(z_rot_angle) -sind(z_rot_angle) 0; sind(z_rot_angle) cosd(z_rot_angle) 0; 0 0 1];
    z_axis_rotation = R_z*y_axis_rotation;

    x_axis_shift = plane_definition(3);
    spatial_info = x_axis_shift*ones(3,numel(x_grid_r)) + z_axis_rotation;

    x_grid = reshape(spatial_info(1,:),nr_b_values,nr_a_values);
    y_grid = reshape(spatial_info(2,:),nr_b_values,nr_a_values);
    z_grid = reshape(spatial_info(3,:),nr_b_values,nr_a_values);
    
end


end

