%% Secondary field, Zeta = 1 , theta_s1 = pi/2 , phi_s1 = pi/2 , theta_s2 = pi/2 , phi_s2 = -pi/2
N=120;
theta_s = [pi/2 pi/2]; phi_s = [pi/2 -pi/2];
% calculate 
[~, p_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_primary( rho, c, a, 0.5, 1, pi, pi/2, N, ka);
[~, s1_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_secondary( rho, c, a, 0.5, 1, pi/2, pi/2, N, ka);
[~, s2_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_secondary( rho, c, a, 0.5, 1, pi/2, -pi/2, N, ka);

% apply control
N=120;
[L,nr_sphh] = size(p_RSHS_coeff_vs_ka);
M = 1;
optimized_q0_EO_CZ = zeros(2,nr_sphh);
G = zeros(L,2);
for index = 1:nr_sphh
%% Define plant G and disturbance signals d
G(:,1) = s1_RSHS_coeff_vs_ka(:,index);
G(:,2) = s2_RSHS_coeff_vs_ka(:,index);
d = p_RSHS_coeff_vs_ka(:,index);
%     % L = number of error signals (measurement sensors). M = number of control signals (actuators)
%     [L,M] = size(G);
%
%
%     %% PART A
%     %----------------------------------------------------------------------------------------------------------------------------------------------------
% Optimal control signals for minimizing the sum of mean-squared error signals
u_opt = -(G'*G)\(G'*d);
% Achieved error signals for optimal control signals
%e_min = d + G*u_opt;
%
optimized_q0_EO_CZ(:,index) = u_opt;
end
if max(isnan(optimized_q0_EO_CZ)) == 1
optimized_q0_EO_CZ(isnan(optimized_q0_EO_CZ) == 1) = 0;
end

[~, c_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_2controlled( rho, c, a, 0.5, 1, pi, pi/2,optimized_q0_EO_CZ.', [pi/2 pi/2], [pi/2 -pi/2], N, ka);


% primary field, check activated RSHSC
flag1 = max(abs([real(c_RSHS_coeff_vs_ka(1,:)) imag(c_RSHS_coeff_vs_ka(1,:))]),[],2) > 10^(-17);
flag2 = max(abs([real(c_RSHS_coeff_vs_ka(2,:)) imag(c_RSHS_coeff_vs_ka(2,:))]),[],2) > 10^(-17);
flag3 = max(abs([real(c_RSHS_coeff_vs_ka(3,:)) imag(c_RSHS_coeff_vs_ka(3,:))]),[],2) > 10^(-17);
flag4 = max(abs([real(c_RSHS_coeff_vs_ka(4,:)) imag(c_RSHS_coeff_vs_ka(4,:))]),[],2) > 10^(-17);
flag5 = max(abs([real(c_RSHS_coeff_vs_ka(5,:)) imag(c_RSHS_coeff_vs_ka(5,:))]),[],2) > 10^(-17);
flag6 = max(abs([real(c_RSHS_coeff_vs_ka(6,:)) imag(c_RSHS_coeff_vs_ka(6,:))]),[],2) > 10^(-17);
flag7 = max(abs([real(c_RSHS_coeff_vs_ka(7,:)) imag(c_RSHS_coeff_vs_ka(7,:))]),[],2) > 10^(-17);
flag8 = max(abs([real(c_RSHS_coeff_vs_ka(8,:)) imag(c_RSHS_coeff_vs_ka(8,:))]),[],2) > 10^(-17);
flag9 = max(abs([real(c_RSHS_coeff_vs_ka(9,:)) imag(c_RSHS_coeff_vs_ka(9,:))]),[],2) > 10^(-17);


% Set up figure and axes
fig1 = figure(1);
set(fig1,'Position',[67 225 0.8*1300 0.8*1486]);

ax1 = subplot(2,1,1);
grid on;
ax2 = subplot(2,1,2);
grid on;

set(ax1,'Position',[0.13 0.545 0.81 0.38]);
set(ax2,'Position',[0.13 0.08 0.81 0.38]);

set(ax1,'Color',[178 213 213]/255);
set(ax2,'Color',[178 213 213]/255);

box(ax1,'on');
set(ax1,'BoxStyle','full','LineWidth',1);
box(ax2,'on');
set(ax2,'BoxStyle','full','LineWidth',1);

xlabel(ax1,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax1,'$ \left | \tilde{D}_{n,m}^{c,r} \right | $','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax1.YLabel,'Position',[0.059 0.1 0]);

set(ax1,'XScale','log');
set(ax1,'YScale','log');
set(ax1,'Xlim',[0.1 100]);
set(ax1,'Ylim',[10^(-4) 10^(2)]);
set(ax1,'YTick',[10^(-4)  10^(-3) 10^(-2) 10^(-1) 10^(0) 10^(1) 10^(2)]); 
set(ax1,'YTickLabel',{'10^{-4}' '10^{-3}' '10^{-2}' '10^{-1}' '10^{0}' '10^{1}' '10^{2}'});


xlabel(ax2,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax2,' $< \tilde{D}_{n,m}^{c,r} $ , radians ','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax2.YLabel,'Position',[0.054 3.1416 -1]);

set(ax2,'XScale','log');
set(ax2,'YScale','linear');
set(ax2,'Xlim',[0.1 100]);
set(ax2,'Ylim',[0 2*pi]);
set(ax2,'Ydir','normal');
set(ax2,'YTick',[0  pi/4  pi/2 3*pi/4 pi 5*pi/4 3*pi/2 7*pi/4 2*pi]); 
set(ax2,'YTickLabel',{'0','^{\pi}/{4}','^{\pi}/{2}','^{3\pi}/{4}','{\pi}','^{5\pi}/{4}','^{3\pi}/{2}','^{7\pi}/{4}','2{\pi}'}); 

xAX = get(ax1,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax1,'YAxis');
set(xAY,'FontSize', 22,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax1,'$ \left | \tilde{D}_{n,m}^{c,r} \right | $','Interpreter','latex','Fontsize',24,'FontWeight','bold');

xAX = get(ax2,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax2,'YAxis');
set(xAY,'FontSize', 18,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax2,' $< \tilde{D}_{n,m}^{c,r} $ , radians ','Interpreter','latex','Fontsize',24,'FontWeight','bold');

tb1 = annotation(fig1,'textbox','String','Active control: primary field + secondary field for {\itZ} = {\it\rho_{0}c_{0}} sphere','LineStyle','none');
set(tb1,'FitBoxToText','off','FontSize',23,'FontWeight', 'bold','FontName','Georgia','HorizontalAlignment','center','VerticalAlignment','middle');
set(tb1,'Position',[0.0202    0.9131    0.9740    0.1000]);

% plot 

RSHSC_name_string = {'{\itn=0} , {\itm=0}'; '{\itn=1} , {\itm=1} , sine'; '{\itn=1} , {\itm=0}'; '{\itn=1} , {\itm=1} ,  cosine'; ...
    '{\itn=2} , {\itm=2} , sine'; '{\itn=2} , {\itm=1} , sine'; '{\itn=2} , {\itm=0}'; '{\itn=2} , {\itm=1} ,  cosine'; '{\itn=2} , {\itm=2} , cosine';};

RSHSC_colors = {[255 0 0]/255;[255 102 0]/255;[255 215 0]/255;[0 255 0]/255;[0 255 255]/255;[0 51 204]/255;[0 0 153]/255;[153 0 153]/255;[255 0 255]/255};

var_c = c_RSHS_coeff_vs_ka([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9],:);

labels_legend = RSHSC_name_string([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9]);
colors_legend = RSHSC_colors([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9]);

hold(ax1,'on');
hold(ax2,'on');

plot(ax1,bsxfun(@times,ka,ones(size(var_c))).',abs(var_c).','-','LineWidth',2);
var_low = atan2(imag(var_c),real(var_c));
var_low(var_low < 0) = var_low(var_low < 0) + 2*pi;
plot(ax2,bsxfun(@times,ka,ones(size(var_c))).',var_low.','-','LineWidth',2);

lines_ch1 = get(ax1,'ch');
lines_ch2 = get(ax2,'ch');

for index = 1:numel(lines_ch1)
    
    lines_ch1(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).Color = colors_legend{numel(lines_ch1)-index+1};
    
    lines_ch2(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).Color = colors_legend{numel(lines_ch1)-index+1};
    
end

l1 = legend(ax1,fliplr(labels_legend));
set(l1,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');

l2 = legend(ax2,fliplr(labels_legend));
set(l2,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');


% Set up figure and axes (q_opt)
fig4 = figure(4);
set(fig4,'Position',[67 225 0.8*1300 0.8*1486]);

ax1 = subplot(2,1,1);
grid on;
ax2 = subplot(2,1,2);
grid on;

set(ax1,'Position',[0.13 0.545 0.81 0.38]);
set(ax2,'Position',[0.13 0.08 0.81 0.38]);

set(ax1,'Color',[178 213 213]/255);
set(ax2,'Color',[178 213 213]/255);

box(ax1,'on');
set(ax1,'BoxStyle','full','LineWidth',1);
box(ax2,'on');
set(ax2,'BoxStyle','full','LineWidth',1);

xlabel(ax1,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax1,'$ \left | \tilde{q}_{opt} \right | $','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax1.YLabel,'Position',[0.054 10^(-5) 0]);

set(ax1,'XScale','log');
set(ax1,'YScale','log');
set(ax1,'Xlim',[0.1 100]);
set(ax1,'Ylim',[10^(-8) 10^(-2)]);
set(ax1,'YTick',[10^(-8)  10^(-7) 10^(-6) 10^(-5) 10^(-4) 10^(-3) 10^(-2)]); 
set(ax1,'YTickLabel',{'10^{-8}' '10^{-7}' '10^{-6}' '10^{-5}' '10^{-4}' '10^{-3}' '10^{-2}'});


xlabel(ax2,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax2,' $< \tilde{q}_{opt} $ , radians ','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax2.YLabel,'Position',[0.054 3.1416 -1]);

set(ax2,'XScale','log');
set(ax2,'YScale','linear');
set(ax2,'Xlim',[0.1 100]);
set(ax2,'Ylim',[0 2*pi]);
set(ax2,'Ydir','normal');
set(ax2,'YTick',[0  pi/4  pi/2 3*pi/4 pi 5*pi/4 3*pi/2 7*pi/4 2*pi]); 
set(ax2,'YTickLabel',{'0','^{\pi}/{4}','^{\pi}/{2}','^{3\pi}/{4}','{\pi}','^{5\pi}/{4}','^{3\pi}/{2}','^{7\pi}/{4}','2{\pi}'}); 

xAX = get(ax1,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax1,'YAxis');
set(xAY,'FontSize', 22,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax1,'$ \left | \tilde{q}_{opt} \right | $','Interpreter','latex','Fontsize',24,'FontWeight','bold');

xAX = get(ax2,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax2,'YAxis');
set(xAY,'FontSize', 18,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax2,' $< \tilde{q}_{opt} $ , radians ','Interpreter','latex','Fontsize',24,'FontWeight','bold');

tb1 = annotation(fig4,'textbox','String','Optimal source strengths for secondary field, {\itZ} = {\it\rho_{0}c_{0}} sphere','LineStyle','none');
set(tb1,'FitBoxToText','off','FontSize',23,'FontWeight', 'bold','FontName','Georgia','HorizontalAlignment','center','VerticalAlignment','middle');
set(tb1,'Position',[0.0202    0.9131    0.9740    0.1000]);

% plot 

flag1 = max(abs([real(optimized_q0_EO_CZ(1,:)) imag(optimized_q0_EO_CZ(1,:))]),[],2) > 10^(-17);
flag2 = max(abs([real(optimized_q0_EO_CZ(2,:)) imag(optimized_q0_EO_CZ(2,:))]),[],2) > 10^(-17);



f_name_string = {['{\it\theta_{s1}} = ' num2str(theta_s(1),3) ' , {\it\phi_{s1}} = ' num2str(theta_s(1),3)]; ...
    ['{\it\theta_{s2}} = ' num2str(theta_s(2),3) ' , {\it\phi_{s2}} = ' num2str(theta_s(2),3)]};
    
f_colors = {[255 255 255]/255;[0 0 0]/255};
f_line_type = {'-';'--'};

labels_legend = f_name_string([flag1 flag2]);
colors_legend = f_colors([flag1 flag2]);
line_type_legend = f_line_type([flag1 flag2]);

hold(ax1,'on');
hold(ax2,'on');

plot(ax1,bsxfun(@times,ka,ones(size(optimized_q0_EO_CZ))).',abs(optimized_q0_EO_CZ).','-','LineWidth',2);
var_low = atan2(imag(optimized_q0_EO_CZ),real(optimized_q0_EO_CZ));
var_low(var_low < 0) = var_low(var_low < 0) + 2*pi;
plot(ax2,bsxfun(@times,ka,ones(size(optimized_q0_EO_CZ))).',var_low.','-','LineWidth',2);

lines_ch1 = get(ax1,'ch');
lines_ch2 = get(ax2,'ch');

for index = 1:numel(lines_ch1)
    
    lines_ch1(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).Color = colors_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).LineStyle = line_type_legend{numel(lines_ch1)-index+1};
    
    lines_ch2(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).Color = colors_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).LineStyle = line_type_legend{numel(lines_ch1)-index+1};
    
end

l1 = legend(ax1,fliplr(f_name_string));
set(l1,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');

l2 = legend(ax2,fliplr(f_name_string));
set(l2,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');




%% Secondary field, Zeta = 100 , theta_s1 = pi/2 , phi_s1 = pi/2 , theta_s2 = pi/2 , phi_s2 = -pi/2

% calculate 
[~, p_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_primary( rho, c, a, 100/101, 1, pi, pi/2, N, ka);
[~, s1_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_secondary( rho, c, a, 100/101, 1, pi/2, pi/2, N, ka);
[~, s2_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_secondary( rho, c, a, 100/101, 1, pi/2, -pi/2, N, ka);

% apply control
N=120;
[L,nr_sphh] = size(p_RSHS_coeff_vs_ka);
M = 1;
optimized_q0_EO_CZ = zeros(2,nr_sphh);
G = zeros(L,2);
for index = 1:nr_sphh
%% Define plant G and disturbance signals d
G(:,1) = s1_RSHS_coeff_vs_ka(:,index);
G(:,2) = s2_RSHS_coeff_vs_ka(:,index);
d = p_RSHS_coeff_vs_ka(:,index);
%     % L = number of error signals (measurement sensors). M = number of control signals (actuators)
%     [L,M] = size(G);
%
%
%     %% PART A
%     %----------------------------------------------------------------------------------------------------------------------------------------------------
% Optimal control signals for minimizing the sum of mean-squared error signals
u_opt = -(G'*G)\(G'*d);
% Achieved error signals for optimal control signals
%e_min = d + G*u_opt;
%
optimized_q0_EO_CZ(:,index) = u_opt;
end
if max(isnan(optimized_q0_EO_CZ)) == 1
optimized_q0_EO_CZ(isnan(optimized_q0_EO_CZ) == 1) = 0;
end

[~, c_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_2controlled( rho, c, a, 100/101, 1, pi, pi/2,optimized_q0_EO_CZ.', [pi/2 pi/2], [pi/2 -pi/2], N, ka);


% primary field, check activated RSHSC
flag1 = max(abs([real(c_RSHS_coeff_vs_ka(1,:)) imag(c_RSHS_coeff_vs_ka(1,:))]),[],2) > 10^(-17);
flag2 = max(abs([real(c_RSHS_coeff_vs_ka(2,:)) imag(c_RSHS_coeff_vs_ka(2,:))]),[],2) > 10^(-17);
flag3 = max(abs([real(c_RSHS_coeff_vs_ka(3,:)) imag(c_RSHS_coeff_vs_ka(3,:))]),[],2) > 10^(-17);
flag4 = max(abs([real(c_RSHS_coeff_vs_ka(4,:)) imag(c_RSHS_coeff_vs_ka(4,:))]),[],2) > 10^(-17);
flag5 = max(abs([real(c_RSHS_coeff_vs_ka(5,:)) imag(c_RSHS_coeff_vs_ka(5,:))]),[],2) > 10^(-17);
flag6 = max(abs([real(c_RSHS_coeff_vs_ka(6,:)) imag(c_RSHS_coeff_vs_ka(6,:))]),[],2) > 10^(-17);
flag7 = max(abs([real(c_RSHS_coeff_vs_ka(7,:)) imag(c_RSHS_coeff_vs_ka(7,:))]),[],2) > 10^(-17);
flag8 = max(abs([real(c_RSHS_coeff_vs_ka(8,:)) imag(c_RSHS_coeff_vs_ka(8,:))]),[],2) > 10^(-17);
flag9 = max(abs([real(c_RSHS_coeff_vs_ka(9,:)) imag(c_RSHS_coeff_vs_ka(9,:))]),[],2) > 10^(-17);


% Set up figure and axes
fig2 = figure(2);
set(fig2,'Position',[67 225 0.8*1300 0.8*1486]);

ax1 = subplot(2,1,1);
grid on;
ax2 = subplot(2,1,2);
grid on;

set(ax1,'Position',[0.13 0.545 0.81 0.38]);
set(ax2,'Position',[0.13 0.08 0.81 0.38]);

set(ax1,'Color',[178 213 213]/255);
set(ax2,'Color',[178 213 213]/255);

box(ax1,'on');
set(ax1,'BoxStyle','full','LineWidth',1);
box(ax2,'on');
set(ax2,'BoxStyle','full','LineWidth',1);

xlabel(ax1,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax1,'$ \left | \tilde{D}_{n,m}^{c,r} \right | $','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax1.YLabel,'Position',[0.059 0.1 0]);

set(ax1,'XScale','log');
set(ax1,'YScale','log');
set(ax1,'Xlim',[0.1 100]);
set(ax1,'Ylim',[10^(-4) 10^(2)]);
set(ax1,'YTick',[10^(-4)  10^(-3) 10^(-2) 10^(-1) 10^(0) 10^(1) 10^(2)]); 
set(ax1,'YTickLabel',{'10^{-4}' '10^{-3}' '10^{-2}' '10^{-1}' '10^{0}' '10^{1}' '10^{2}'});


xlabel(ax2,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax2,' $< \tilde{D}_{n,m}^{c,r} $ , radians ','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax2.YLabel,'Position',[0.054 3.1416 -1]);

set(ax2,'XScale','log');
set(ax2,'YScale','linear');
set(ax2,'Xlim',[0.1 100]);
set(ax2,'Ylim',[0 2*pi]);
set(ax2,'Ydir','normal');
set(ax2,'YTick',[0  pi/4  pi/2 3*pi/4 pi 5*pi/4 3*pi/2 7*pi/4 2*pi]); 
set(ax2,'YTickLabel',{'0','^{\pi}/{4}','^{\pi}/{2}','^{3\pi}/{4}','{\pi}','^{5\pi}/{4}','^{3\pi}/{2}','^{7\pi}/{4}','2{\pi}'}); 

xAX = get(ax1,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax1,'YAxis');
set(xAY,'FontSize', 22,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax1,'$ \left | \tilde{D}_{n,m}^{c,r} \right | $','Interpreter','latex','Fontsize',24,'FontWeight','bold');

xAX = get(ax2,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax2,'YAxis');
set(xAY,'FontSize', 18,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax2,' $< \tilde{D}_{n,m}^{c,r} $ , radians ','Interpreter','latex','Fontsize',24,'FontWeight','bold');

tb1 = annotation(fig2,'textbox','String','Active control: primary field + secondary field for {\itZ} = 100{\it\rho_{0}c_{0}} sphere','LineStyle','none');
set(tb1,'FitBoxToText','off','FontSize',23,'FontWeight', 'bold','FontName','Georgia','HorizontalAlignment','center','VerticalAlignment','middle');
set(tb1,'Position',[0.0202    0.9131    0.9740    0.1000]);

% plot 

RSHSC_name_string = {'{\itn=0} , {\itm=0}'; '{\itn=1} , {\itm=1} , sine'; '{\itn=1} , {\itm=0}'; '{\itn=1} , {\itm=1} ,  cosine'; ...
    '{\itn=2} , {\itm=2} , sine'; '{\itn=2} , {\itm=1} , sine'; '{\itn=2} , {\itm=0}'; '{\itn=2} , {\itm=1} ,  cosine'; '{\itn=2} , {\itm=2} , cosine';};

RSHSC_colors = {[255 0 0]/255;[255 102 0]/255;[255 215 0]/255;[0 255 0]/255;[0 255 255]/255;[0 51 204]/255;[0 0 153]/255;[153 0 153]/255;[255 0 255]/255};

var_c = c_RSHS_coeff_vs_ka([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9],:);

labels_legend = RSHSC_name_string([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9]);
colors_legend = RSHSC_colors([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9]);

hold(ax1,'on');
hold(ax2,'on');

plot(ax1,bsxfun(@times,ka,ones(size(var_c))).',abs(var_c).','-','LineWidth',2);
var_low = atan2(imag(var_c),real(var_c));
var_low(var_low < 0) = var_low(var_low < 0) + 2*pi;
plot(ax2,bsxfun(@times,ka,ones(size(var_c))).',var_low.','-','LineWidth',2);

lines_ch1 = get(ax1,'ch');
lines_ch2 = get(ax2,'ch');

for index = 1:numel(lines_ch1)
    
    lines_ch1(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).Color = colors_legend{numel(lines_ch1)-index+1};
    
    lines_ch2(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).Color = colors_legend{numel(lines_ch1)-index+1};
    
end

l1 = legend(ax1,fliplr(labels_legend));
set(l1,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');

l2 = legend(ax2,fliplr(labels_legend));
set(l2,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');



% Set up figure and axes (q_opt)
fig5 = figure(5);
set(fig5,'Position',[67 225 0.8*1300 0.8*1486]);

ax1 = subplot(2,1,1);
grid on;
ax2 = subplot(2,1,2);
grid on;

set(ax1,'Position',[0.13 0.545 0.81 0.38]);
set(ax2,'Position',[0.13 0.08 0.81 0.38]);

set(ax1,'Color',[178 213 213]/255);
set(ax2,'Color',[178 213 213]/255);

box(ax1,'on');
set(ax1,'BoxStyle','full','LineWidth',1);
box(ax2,'on');
set(ax2,'BoxStyle','full','LineWidth',1);

xlabel(ax1,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax1,'$ \left | \tilde{q}_{opt} \right | $','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax1.YLabel,'Position',[0.054 10^(-5) 0]);

set(ax1,'XScale','log');
set(ax1,'YScale','log');
set(ax1,'Xlim',[0.1 100]);
set(ax1,'Ylim',[10^(-8) 10^(-2)]);
set(ax1,'YTick',[10^(-8)  10^(-7) 10^(-6) 10^(-5) 10^(-4) 10^(-3) 10^(-2)]); 
set(ax1,'YTickLabel',{'10^{-8}' '10^{-7}' '10^{-6}' '10^{-5}' '10^{-4}' '10^{-3}' '10^{-2}'});


xlabel(ax2,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax2,' $< \tilde{q}_{opt} $ , radians ','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax2.YLabel,'Position',[0.054 3.1416 -1]);

set(ax2,'XScale','log');
set(ax2,'YScale','linear');
set(ax2,'Xlim',[0.1 100]);
set(ax2,'Ylim',[0 2*pi]);
set(ax2,'Ydir','normal');
set(ax2,'YTick',[0  pi/4  pi/2 3*pi/4 pi 5*pi/4 3*pi/2 7*pi/4 2*pi]); 
set(ax2,'YTickLabel',{'0','^{\pi}/{4}','^{\pi}/{2}','^{3\pi}/{4}','{\pi}','^{5\pi}/{4}','^{3\pi}/{2}','^{7\pi}/{4}','2{\pi}'}); 

xAX = get(ax1,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax1,'YAxis');
set(xAY,'FontSize', 22,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax1,'$ \left | \tilde{q}_{opt} \right | $','Interpreter','latex','Fontsize',24,'FontWeight','bold');

xAX = get(ax2,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax2,'YAxis');
set(xAY,'FontSize', 18,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax2,' $< \tilde{q}_{opt} $ , radians ','Interpreter','latex','Fontsize',24,'FontWeight','bold');

tb1 = annotation(fig5,'textbox','String','Optimal source strengths for secondary field, {\itZ} = 100{\it\rho_{0}c_{0}} sphere','LineStyle','none');
set(tb1,'FitBoxToText','off','FontSize',23,'FontWeight', 'bold','FontName','Georgia','HorizontalAlignment','center','VerticalAlignment','middle');
set(tb1,'Position',[0.0202    0.9131    0.9740    0.1000]);

% plot 

flag1 = max(abs([real(optimized_q0_EO_CZ(1,:)) imag(optimized_q0_EO_CZ(1,:))]),[],2) > 10^(-17);
flag2 = max(abs([real(optimized_q0_EO_CZ(2,:)) imag(optimized_q0_EO_CZ(2,:))]),[],2) > 10^(-17);


f_name_string = {['{\it\theta_{s1}} = ' num2str(theta_s(1),3) ' , {\it\phi_{s1}} = ' num2str(theta_s(1),3)]; ...
    ['{\it\theta_{s2}} = ' num2str(theta_s(2),3) ' , {\it\phi_{s2}} = ' num2str(theta_s(2),3)]};
    
f_colors = {[255 255 255]/255;[0 0 0]/255};
f_line_type = {'-';'--';};

labels_legend = f_name_string([flag1 flag2]);
colors_legend = f_colors([flag1 flag2]);
line_type_legend = f_line_type([flag1 flag2]);

hold(ax1,'on');
hold(ax2,'on');

plot(ax1,bsxfun(@times,ka,ones(size(optimized_q0_EO_CZ))).',abs(optimized_q0_EO_CZ).','-','LineWidth',2);
var_low = atan2(imag(optimized_q0_EO_CZ),real(optimized_q0_EO_CZ));
var_low(var_low < 0) = var_low(var_low < 0) + 2*pi;
plot(ax2,bsxfun(@times,ka,ones(size(optimized_q0_EO_CZ))).',var_low.','-','LineWidth',2);

lines_ch1 = get(ax1,'ch');
lines_ch2 = get(ax2,'ch');

for index = 1:numel(lines_ch1)
    
    lines_ch1(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).Color = colors_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).LineStyle = line_type_legend{numel(lines_ch1)-index+1};
    
    lines_ch2(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).Color = colors_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).LineStyle = line_type_legend{numel(lines_ch1)-index+1};
    
end

l1 = legend(ax1,fliplr(f_name_string));
set(l1,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');

l2 = legend(ax2,fliplr(f_name_string));
set(l2,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');




%% Secondary field, Zeta = 0.01 , theta_s1 = pi/2 , phi_s1 = pi/2 , theta_s2 = pi/2 , phi_s2 = -pi/2

% calculate 
[~, p_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_primary( rho, c, a, 0.01/1.01, 1, pi, pi/2, N, ka);
[~, s1_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_secondary( rho, c, a, 0.01/1.01, 1, pi/2, pi/2, N, ka);
[~, s2_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_secondary( rho, c, a, 0.01/1.01, 1, pi/2, -pi/2, N, ka);

% apply control
N=120;
[L,nr_sphh] = size(p_RSHS_coeff_vs_ka);
M = 1;
optimized_q0_EO_CZ = zeros(2,nr_sphh);
G = zeros(L,2);
for index = 1:nr_sphh
%% Define plant G and disturbance signals d
G(:,1) = s1_RSHS_coeff_vs_ka(:,index);
G(:,2) = s2_RSHS_coeff_vs_ka(:,index);
d = p_RSHS_coeff_vs_ka(:,index);
%     % L = number of error signals (measurement sensors). M = number of control signals (actuators)
%     [L,M] = size(G);
%
%
%     %% PART A
%     %----------------------------------------------------------------------------------------------------------------------------------------------------
% Optimal control signals for minimizing the sum of mean-squared error signals
u_opt = -(G'*G)\(G'*d);
% Achieved error signals for optimal control signals
%e_min = d + G*u_opt;
%
optimized_q0_EO_CZ(:,index) = u_opt;
end
if max(isnan(optimized_q0_EO_CZ)) == 1
optimized_q0_EO_CZ(isnan(optimized_q0_EO_CZ) == 1) = 0;
end

[~, c_RSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_2controlled( rho, c, a, 0.01/1.01, 1, pi, pi/2,optimized_q0_EO_CZ.', [pi/2 pi/2], [pi/2 -pi/2], N, ka);


% primary field, check activated RSHSC
flag1 = max(abs([real(c_RSHS_coeff_vs_ka(1,:)) imag(c_RSHS_coeff_vs_ka(1,:))]),[],2) > 10^(-17);
flag2 = max(abs([real(c_RSHS_coeff_vs_ka(2,:)) imag(c_RSHS_coeff_vs_ka(2,:))]),[],2) > 10^(-17);
flag3 = max(abs([real(c_RSHS_coeff_vs_ka(3,:)) imag(c_RSHS_coeff_vs_ka(3,:))]),[],2) > 10^(-17);
flag4 = max(abs([real(c_RSHS_coeff_vs_ka(4,:)) imag(c_RSHS_coeff_vs_ka(4,:))]),[],2) > 10^(-17);
flag5 = max(abs([real(c_RSHS_coeff_vs_ka(5,:)) imag(c_RSHS_coeff_vs_ka(5,:))]),[],2) > 10^(-17);
flag6 = max(abs([real(c_RSHS_coeff_vs_ka(6,:)) imag(c_RSHS_coeff_vs_ka(6,:))]),[],2) > 10^(-17);
flag7 = max(abs([real(c_RSHS_coeff_vs_ka(7,:)) imag(c_RSHS_coeff_vs_ka(7,:))]),[],2) > 10^(-17);
flag8 = max(abs([real(c_RSHS_coeff_vs_ka(8,:)) imag(c_RSHS_coeff_vs_ka(8,:))]),[],2) > 10^(-17);
flag9 = max(abs([real(c_RSHS_coeff_vs_ka(9,:)) imag(c_RSHS_coeff_vs_ka(9,:))]),[],2) > 10^(-17);


% Set up figure and axes
fig3 = figure(3);
set(fig3,'Position',[67 225 0.8*1300 0.8*1486]);

ax1 = subplot(2,1,1);
grid on;
ax2 = subplot(2,1,2);
grid on;

set(ax1,'Position',[0.13 0.545 0.81 0.38]);
set(ax2,'Position',[0.13 0.08 0.81 0.38]);

set(ax1,'Color',[178 213 213]/255);
set(ax2,'Color',[178 213 213]/255);

box(ax1,'on');
set(ax1,'BoxStyle','full','LineWidth',1);
box(ax2,'on');
set(ax2,'BoxStyle','full','LineWidth',1);

xlabel(ax1,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax1,'$ \left | \tilde{D}_{n,m}^{c,r} \right | $','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax1.YLabel,'Position',[0.059 0.1 0]);

set(ax1,'XScale','log');
set(ax1,'YScale','log');
set(ax1,'Xlim',[0.1 100]);
set(ax1,'Ylim',[10^(-4) 10^(2)]);
set(ax1,'YTick',[10^(-4)  10^(-3) 10^(-2) 10^(-1) 10^(0) 10^(1) 10^(2)]); 
set(ax1,'YTickLabel',{'10^{-4}' '10^{-3}' '10^{-2}' '10^{-1}' '10^{0}' '10^{1}' '10^{2}'});


xlabel(ax2,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax2,' $< \tilde{D}_{n,m}^{c,r} $ , radians ','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax2.YLabel,'Position',[0.054 3.1416 -1]);

set(ax2,'XScale','log');
set(ax2,'YScale','linear');
set(ax2,'Xlim',[0.1 100]);
set(ax2,'Ylim',[0 2*pi]);
set(ax2,'Ydir','normal');
set(ax2,'YTick',[0  pi/4  pi/2 3*pi/4 pi 5*pi/4 3*pi/2 7*pi/4 2*pi]); 
set(ax2,'YTickLabel',{'0','^{\pi}/{4}','^{\pi}/{2}','^{3\pi}/{4}','{\pi}','^{5\pi}/{4}','^{3\pi}/{2}','^{7\pi}/{4}','2{\pi}'}); 

xAX = get(ax1,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax1,'YAxis');
set(xAY,'FontSize', 22,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax1,'$ \left | \tilde{D}_{n,m}^{c,r} \right | $','Interpreter','latex','Fontsize',24,'FontWeight','bold');

xAX = get(ax2,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax2,'YAxis');
set(xAY,'FontSize', 18,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax2,' $< \tilde{D}_{n,m}^{c,r} $ , radians ','Interpreter','latex','Fontsize',24,'FontWeight','bold');

tb1 = annotation(fig3,'textbox','String','Active control: primary field + secondary field for {\itZ} = 0.01{\it\rho_{0}c_{0}} sphere','LineStyle','none');
set(tb1,'FitBoxToText','off','FontSize',23,'FontWeight', 'bold','FontName','Georgia','HorizontalAlignment','center','VerticalAlignment','middle');
set(tb1,'Position',[0.0202    0.9131    0.9740    0.1000]);

% plot 

RSHSC_name_string = {'{\itn=0} , {\itm=0}'; '{\itn=1} , {\itm=1} , sine'; '{\itn=1} , {\itm=0}'; '{\itn=1} , {\itm=1} ,  cosine'; ...
    '{\itn=2} , {\itm=2} , sine'; '{\itn=2} , {\itm=1} , sine'; '{\itn=2} , {\itm=0}'; '{\itn=2} , {\itm=1} ,  cosine'; '{\itn=2} , {\itm=2} , cosine';};

RSHSC_colors = {[255 0 0]/255;[255 102 0]/255;[255 215 0]/255;[0 255 0]/255;[0 255 255]/255;[0 51 204]/255;[0 0 153]/255;[153 0 153]/255;[255 0 255]/255};

var_c = c_RSHS_coeff_vs_ka([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9],:);

labels_legend = RSHSC_name_string([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9]);
colors_legend = RSHSC_colors([flag1 flag2 flag3 flag4 flag5 flag6 flag7 flag8 flag9]);

hold(ax1,'on');
hold(ax2,'on');

plot(ax1,bsxfun(@times,ka,ones(size(var_c))).',abs(var_c).','-','LineWidth',2);
var_low = atan2(imag(var_c),real(var_c));
var_low(var_low < 0) = var_low(var_low < 0) + 2*pi;
plot(ax2,bsxfun(@times,ka,ones(size(var_c))).',var_low.','-','LineWidth',2);

lines_ch1 = get(ax1,'ch');
lines_ch2 = get(ax2,'ch');

for index = 1:numel(lines_ch1)
    
    lines_ch1(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).Color = colors_legend{numel(lines_ch1)-index+1};
    
    lines_ch2(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).Color = colors_legend{numel(lines_ch1)-index+1};
    
end

l1 = legend(ax1,fliplr(labels_legend));
set(l1,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');

l2 = legend(ax2,fliplr(labels_legend));
set(l2,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');

% Set up figure and axes (q_opt)
fig6 = figure(6);
set(fig6,'Position',[67 225 0.8*1300 0.8*1486]);

ax1 = subplot(2,1,1);
grid on;
ax2 = subplot(2,1,2);
grid on;

set(ax1,'Position',[0.13 0.545 0.81 0.38]);
set(ax2,'Position',[0.13 0.08 0.81 0.38]);

set(ax1,'Color',[178 213 213]/255);
set(ax2,'Color',[178 213 213]/255);

box(ax1,'on');
set(ax1,'BoxStyle','full','LineWidth',1);
box(ax2,'on');
set(ax2,'BoxStyle','full','LineWidth',1);

xlabel(ax1,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax1,'$ \left | \tilde{q}_{opt} \right | $','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax1.YLabel,'Position',[0.054 10^(-3) 0]);

set(ax1,'XScale','log');
set(ax1,'YScale','log');
set(ax1,'Xlim',[0.1 100]);
set(ax1,'Ylim',[10^(-6) 10^(0)]);
set(ax1,'YTick',[10^(-6)  10^(-5) 10^(-4) 10^(-3) 10^(-2) 10^(-1) 10^(0)]); 
set(ax1,'YTickLabel',{'10^{-6}' '10^{-5}' '10^{-4}' '10^{-3}' '10^{-2}' '10^{-1}' '10^{0}'});

xlabel(ax2,'{\itka}','Fontsize',8,'FontWeight','bold');
ylabel(ax2,' $< \tilde{q}_{opt} $ , radians ','Interpreter','latex','Fontsize',8,'FontWeight','bold');
set(ax2.YLabel,'Position',[0.054 3.1416 -1]);

set(ax2,'XScale','log');
set(ax2,'YScale','linear');
set(ax2,'Xlim',[0.1 100]);
set(ax2,'Ylim',[0 2*pi]);
set(ax2,'Ydir','normal');
set(ax2,'YTick',[0  pi/4  pi/2 3*pi/4 pi 5*pi/4 3*pi/2 7*pi/4 2*pi]); 
set(ax2,'YTickLabel',{'0','^{\pi}/{4}','^{\pi}/{2}','^{3\pi}/{4}','{\pi}','^{5\pi}/{4}','^{3\pi}/{2}','^{7\pi}/{4}','2{\pi}'}); 

xAX = get(ax1,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax1,'YAxis');
set(xAY,'FontSize', 22,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax1,'$ \left | \tilde{q}_{opt} \right | $','Interpreter','latex','Fontsize',24,'FontWeight','bold');

xAX = get(ax2,'XAxis');
set(xAX,'FontSize', 22,'FontWeight','bold');
set(xAX,'FontName', 'Georgia');
xAY = get(ax2,'YAxis');
set(xAY,'FontSize', 18,'FontWeight','bold');
set(xAY,'FontName', 'Georgia');
ylabel(ax2,' $< \tilde{q}_{opt} $ , radians ','Interpreter','latex','Fontsize',24,'FontWeight','bold');

tb1 = annotation(fig6,'textbox','String','Optimal source strengths for secondary field, {\itZ} = 0.01{\it\rho_{0}c_{0}} sphere','LineStyle','none');
set(tb1,'FitBoxToText','off','FontSize',23,'FontWeight', 'bold','FontName','Georgia','HorizontalAlignment','center','VerticalAlignment','middle');
set(tb1,'Position',[0.0202    0.9131    0.9740    0.1000]);

% plot 

flag1 = max(abs([real(optimized_q0_EO_CZ(1,:)) imag(optimized_q0_EO_CZ(1,:))]),[],2) > 10^(-17);
flag2 = max(abs([real(optimized_q0_EO_CZ(2,:)) imag(optimized_q0_EO_CZ(2,:))]),[],2) > 10^(-17);



f_name_string = {['{\it\theta_{s1}} = ' num2str(theta_s(1),3) ' , {\it\phi_{s1}} = ' num2str(theta_s(1),3)]; ...
    ['{\it\theta_{s2}} = ' num2str(theta_s(2),3) ' , {\it\phi_{s2}} = ' num2str(theta_s(2),3)]};
    
f_colors = {[255 255 255]/255;[0 0 0]/255};
f_line_type = {'-';'--'};

labels_legend = f_name_string([flag1 flag2]);
colors_legend = f_colors([flag1 flag2]);
line_type_legend = f_line_type([flag1 flag2]);

hold(ax1,'on');
hold(ax2,'on');

plot(ax1,bsxfun(@times,ka,ones(size(optimized_q0_EO_CZ))).',abs(optimized_q0_EO_CZ).','-','LineWidth',2);
var_low = atan2(imag(optimized_q0_EO_CZ),real(optimized_q0_EO_CZ));
var_low(var_low < 0) = var_low(var_low < 0) + 2*pi;
plot(ax2,bsxfun(@times,ka,ones(size(optimized_q0_EO_CZ))).',var_low.','-','LineWidth',2);

lines_ch1 = get(ax1,'ch');
lines_ch2 = get(ax2,'ch');

for index = 1:numel(lines_ch1)
    
    lines_ch1(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).Color = colors_legend{numel(lines_ch1)-index+1};
    lines_ch1(index).LineStyle = line_type_legend{numel(lines_ch1)-index+1};
    
    lines_ch2(index).DisplayName = labels_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).Color = colors_legend{numel(lines_ch1)-index+1};
    lines_ch2(index).LineStyle = line_type_legend{numel(lines_ch1)-index+1};
    
end

l1 = legend(ax1,fliplr(f_name_string));
set(l1,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');

l2 = legend(ax2,fliplr(f_name_string));
set(l2,'Location','best','Color',[212 208 200]/255,'Linewidth',1,'FontSize',16,'FontName','Georgia','TextColor','black');
