function [CSHS_coeff_vs_ka, DRSHS_coeff_vs_ka] = acous_scattering_RSHS_coeff_pos_4controlled( rho, c, a, Z_norm, q_p, theta_p, phi_p, q_s, r_prime, theta_s, phi_s, N, ka)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here


k = ka/a;


CSHS_coeff_vs_ka = zeros((N+1)^2,numel(ka));
RSHS_coeff_vs_ka = zeros((N+1)^2,numel(ka));
%CSHS_coeff_n_contrib_vs_ka = zeros(N+1,numel(ka));

DRSHS_coeff_vs_ka = zeros(N+1,numel(ka));

for n = 0:N

    
    Y_p = spherical_harmonics(n,theta_p,phi_p);
    Y_s = [spherical_harmonics(n,theta_s(1),phi_s(1)) spherical_harmonics(n,theta_s(2),phi_s(2)) spherical_harmonics(n,theta_s(3),phi_s(3)) spherical_harmonics(n,theta_s(4),phi_s(4))];


    % variable storing the factor based of derivatives of Bessel functions, matrix format (number of frequencies)x1;
    bessel_constant_j_N = radial_functions('j',n,ka.');  
    bessel_constant_h_N = radial_functions('h2',n,ka.');  
    bessel_constant_j_prime_N = radial_functions_prime('j',n,ka.');  
    bessel_constant_h_prime_N = radial_functions_prime('h2',n,ka.');
    
    pos_bessel_constant_j_N = radial_functions('j',n,(k*r_prime).');  
    pos_bessel_constant_h_N = radial_functions('h2',n,(k*r_prime).');  
    
    
    %bessel_prime_N2 = radial_functions_prime('j',N,var2.')./radial_functions_prime('h2',N,var2.');  
    
    alpha1 = 1i*(ones(size(Z_norm))-Z_norm).';
    alpha2 = -Z_norm.';
    
    impedance_constant_N = ( bsxfun(@times,bessel_constant_j_N,alpha1) + bsxfun(@times,bessel_constant_j_prime_N,alpha2) ) ./ ( bsxfun(@times,bessel_constant_h_N,alpha1) + bsxfun(@times,bessel_constant_h_prime_N,alpha2) );


    
%         
%     if n == 0
%         
%       var5 = bsxfun(@times,bessel_constant_j_N,ones(numel(wavenumber),1)) - bsxfun(@times,bessel_constant_h_N,impedance_constant_N);
%     
% %         var4 = bsxfun(@times,(wavenumber.').^2,var5);
%    
%         var4 = bsxfun(@times, (wavenumber.').^2, rho*c*conj(Y_s(1))*var5);
%         
%         var3 = abs( bsxfun(@times,q0,var4) -P0*4*pi*(1i)^n*conj(Y_i(1))*impedance_constant_N ).^2;
%         
%         var2 = bsxfun(@times,var3,1./(wavenumber.').^2)/(2*rho*c);
%         
%         if max(isnan(var2)) == 1
%             
%             var2(isnan(var2) == 1) = 0;
% 
%         end
%         
%         
%         coefficients_vs_ka(1,:) = bsxfun(@times,abs(q0.^2),var2);
%         
%         coefficients_n_contrib(1,:) = coefficients_vs_ka(1,:);
%     
%         continue;
%         
%     end
    
    
    
    for m = 1:(2*n+1)
        
        var6 = bsxfun(@times,pos_bessel_constant_j_N,ones(numel(k),1)) - bsxfun(@times,pos_bessel_constant_h_N,impedance_constant_N);
        var5 = bsxfun(@times,bessel_constant_j_N,ones(numel(k),1)) - bsxfun(@times,bessel_constant_h_N,impedance_constant_N);
    
%         var4 = bsxfun(@times,(wavenumber.').^2,var5);
   
        var4 = bsxfun(@times, (k.').^2, rho*c*conj(Y_s(m,1))*var5);
        var3 = bsxfun(@times, (k.').^2, rho*c*conj(Y_s(m,2))*var5);
        var2 = bsxfun(@times, (k.').^2, rho*c*conj(Y_s(m,3))*var6);
        var1 = bsxfun(@times, (k.').^2, rho*c*conj(Y_s(m,4))*var6);
        
        %var3 = abs( bsxfun(@times,q0,var4) -P0*4*pi*(1i)^n*conj(Y_i(m))*impedance_constant_N ).^2;
        var0 =  bsxfun(@times,q_s(:,1),var4)+bsxfun(@times,q_s(:,2),var3)+bsxfun(@times,q_s(:,3),var2)+bsxfun(@times,q_s(:,4),var1)...
            -q_p*4*pi*(1i)^n*conj(Y_p(m))*impedance_constant_N ;
        
        %var2 = bsxfun(@times,var3,1./(wavenumber.').^2)/(2*rho*c);
        
        if max(isnan(var0)) == 1
            
            var0(isnan(var0) == 1) = 0;

        end
    
        
        CSHS_coeff_vs_ka(n^2+m,:) = var0;  
        
        %CSHS_coeff_n_contrib_vs_ka(n+1,:) = CSHS_coeff_n_contrib_vs_ka(n+1,:) + CSHS_coeff_vs_ka(n^2+m,:); 
    
      

    end

    DRSHS_coeff_vs_ka(n+1,:) = CSHS_coeff_vs_ka(n^2+n+1,:);

    if n == 0
        
        RSHS_coeff_vs_ka(1,:) = CSHS_coeff_vs_ka(1,:);
        
    else
        
        RSHS_coeff_vs_ka(n^2+1:n^2+2*n+1,:) =  (sqrt(2)/2)*[(bsxfun(@times,((-1).^[n:-1:1]).',-CSHS_coeff_vs_ka(n^2+1:n^2+n,:)) + CSHS_coeff_vs_ka(n^2+n+2:n^2+2*n+1,:))*1i; (2/sqrt(2))*CSHS_coeff_vs_ka(n^2+n+1,:); ...
                                                     bsxfun(@times,((-1).^[1:1:n]).',CSHS_coeff_vs_ka(n^2+1:n^2+n,:)) + CSHS_coeff_vs_ka(n^2+n+2:n^2+2*n+1,:)]; 
                                                 
    end
                                        
    
end



end