ka = logspace(log10(0.001),log10(100),5001);       % Normalized frequency (by external radius of shell)
N = 6;                                         % Truncation degree of infinite series;
n_index = (0:N).';
lambda_n = n_index.*(n_index+1).*ka./ka;
%% Exterior fluid properties
rho = 1000;%1.21;             % fluid density (kg/m^3)
c = 1460;%343;                % speed of sound in fluid (m/s);
%% Spherical shell properties
a = 0.3;                % External radius of spherical shell (m)
E = 190*10^9;%          % Young`s modulus of shell material (Pa)
v = 0.27;              % Poisson`s ratio of shell material
rho_s = 7700;          % Density of shell material(kg/m^3)
p = 0.5;                 % Spherical shell thickness as percentage of external radius (%)
h = a*p/100;           % Spherical shell thickness (m)
% a = 0.3;                % External radius of spherical shell (m)
% E = 0.0025*10^9;% 190*10^9;%          % Young`s modulus of shell material (Pa)
% v = 0.5;%0.27;              % Poisson`s ratio of shell material
% rho_s = 930;%7700;          % Density of shell material(kg/m^3)
% p = 0.5;                 % Spherical shell thickness as percentage of external radius (%)
% h = a*p/100;           % Spherical shell thickness (m)

beta_2 = h^2/(12*a^2);
cp_2 = E/(rho_s*(1-v^2));
omega = (c/sqrt(cp_2))*ka.*(n_index+1)./(n_index+1);
lambda = n_index.*(n_index+1);
C1 = -(beta_2*(v+lambda-1)*cp_2/c^2+(1+v)*cp_2/c^2);
C2 = -((v+lambda-1)*cp_2/c^2+beta_2*(v+lambda-1)*cp_2/c^2);
C3 = -(2*(1+v)+beta_2*lambda.*(v+lambda-1))*(cp_2/c^2);
C4 = -lambda.*(beta_2*(v+lambda-1)+(1+v))*cp_2/c^2;
C5 = -(cp_2/c^2)*a^2*(1-v^2)/(E*h)*ones(7,1);
fa = sqrt((-(C2+C3)+sqrt((C2+C3).^2-4*(C2.*C3-C1.*C4)))/2);
fb = sqrt((-(C2+C3)-sqrt((C2+C3).^2-4*(C2.*C3-C1.*C4)))/2);
VW_a = -C1./(fa.^2+C2);
VW_b = -C1./(fb.^2+C2);

syms x real 

var = zeros(7,2);
pol = imag(((-1i*a/c)*x^4+(-1i*a/c)*(C2(1)+C3(1))*x^2+(-1i*a/c)*(C2(1)*C3(1)-C1(1)*C4(1)))/(C5(1)*x^3+x*C2(1)*C5(1))+rho*c*(-x/(1i-x)));
[N,M]=numden(pol);
flag=roots(sym2poly((N)));
flag1 = flag(imag(flag)== 0 & real(flag)>=0 );
var(1,1) = max(flag1);
var(1,2) = min(flag1);
pol = imag(((-1i*a/c)*x^4+(-1i*a/c)*(C2(2)+C3(2))*x^2+(-1i*a/c)*(C2(2)*C3(2)-C1(2)*C4(2)))/(C5(2)*x^3+x*C2(2)*C5(2))+rho*c*(1i*x*(x-1i)/(1i*x^2+2*x-2i)));
[N,M]=numden(pol);
flag=roots(sym2poly((N)));
flag1 = flag(imag(flag)== 0 & real(flag)>=0 );
var(2,1) = max(flag1);
var(2,2) = min(flag1);
pol = imag(((-1i*a/c)*x^4+(-1i*a/c)*(C2(3)+C3(3))*x^2+(-1i*a/c)*(C2(3)*C3(3)-C1(3)*C4(3)))/(C5(3)*x^3+x*C2(3)*C5(3))+rho*c*((x^3-3i*x^2-3*x)/(x^3-4i*x^2-9*x+9i)));
[N,M]=numden(pol);
flag=roots(sym2poly((N)));
flag1 = flag(imag(flag)== 0 & real(flag)>=0 );
var(3,1) = max(flag1);
var(3,2) = min(flag1);
pol = imag(((-1i*a/c)*x^4+(-1i*a/c)*(C2(4)+C3(4))*x^2+(-1i*a/c)*(C2(4)*C3(4)-C1(4)*C4(4)))/(C5(4)*x^3+x*C2(4)*C5(4))+rho*c*((-1i*x^4-6*x^3+15i*x^2+15*x)/(-1i*x^4-7*x^3+27i*x^2+60*x-60i)));
[N,M]=numden(pol);
flag=roots(sym2poly((N)));
flag1 = flag(imag(flag)== 0 & real(flag)>=0 );
var(4,1) = max(flag1);
var(4,2) = min(flag1);
pol = imag(((-1i*a/c)*x^4+(-1i*a/c)*(C2(5)+C3(5))*x^2+(-1i*a/c)*(C2(5)*C3(5)-C1(5)*C4(5)))/(C5(5)*x^3+x*C2(5)*C5(5))+rho*c*((x^5-10i*x^4-45*x^3+105i*x^2+105*x)/(x^5-11i*x^4-65*x^3+240i*x^2+525*x-525i)));
[N,M]=numden(pol);
flag=roots(sym2poly((N)));
flag1 = flag(imag(flag)== 0 & real(flag)>=0 );
var(5,1) = max(flag1);
var(5,2) = min(flag1);
pol = imag(((-1i*a/c)*x^4+(-1i*a/c)*(C2(6)+C3(6))*x^2+(-1i*a/c)*(C2(6)*C3(6)-C1(6)*C4(6)))/(C5(6)*x^3+x*C2(6)*C5(6))+rho*c*((1i*x^6+15*x^5-105i*x^4-420*x^3+945i*x^2+945*x)/(1i*x^6+16*x^5-135i*x^4-735*x^3+2625i*x^2+5670*x-5670i)));
[N,M]=numden(pol);
flag=roots(sym2poly((N)));
flag1 = flag(imag(flag)== 0 & real(flag)>=0 );
var(6,1) = max(flag1);
var(6,2) = min(flag1);
fa_l=var(1:end,1);
fb_l=var(1:end,2);
VW_a_l = -C1./(fa_l.^2+C2);
VW_b_l = -C1./(fb_l.^2+C2);